/*  libhrel - Holyrel library

    Copyright (C) 2005 Chong Kai Xiong <descender@phreaker.net>

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public
    License along with this library; if not, write to the
    Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA  02111-1307  USA.
*/

#include <config.h>
#include <libhrel/gtk_relation_store.h>

static void h_gtk_relation_store_tree_model_init (GtkTreeModelIface *iface);
static void h_gtk_relation_store_dispose         (GObject           *object);
static void h_gtk_relation_store_finalize        (GObject           *object);

G_DEFINE_TYPE_EXTENDED (HGtkRelationStore,
                        h_gtk_relation_store,
                        G_TYPE_OBJECT,
                        0,
                        G_IMPLEMENT_INTERFACE (GTK_TYPE_TREE_MODEL,
                                               h_gtk_relation_store_tree_model_init))

static void
h_gtk_relation_store_tree_model_init (GtkTreeModelIface *iface)
{
/*
  iface->get_flags = h_gtk_relation_store_get_flags;
  iface->get_n_columns = h_gtk_relation_store_get_n_columns;
  iface->get_column_type = h_gtk_relation_store_get_column_type;
  iface->get_iter = h_gtk_relation_store_get_iter;
  iface->get_path = h_gtk_relation_store_get_path;
  iface->get_value = h_gtk_relation_store_get_value;
  iface->iter_next = h_gtk_relation_store_iter_next;
  iface->iter_children = h_gtk_relation_store_iter_children;
  iface->iter_has_child = h_gtk_relation_store_iter_has_child;
  iface->iter_n_children = h_gtk_relation_store_iter_n_children;
  iface->iter_nth_child = h_gtk_relation_store_iter_nth_child;
  iface->iter_parent = h_gtk_relation_store_iter_parent;
*/
}

static void
h_gtk_relation_store_class_init (HGtkRelationStoreClass *klass)
{
  GObjectClass *object_class = G_OBJECT_CLASS (klass);

  object_class->dispose = h_gtk_relation_store_dispose;
  object_class->finalize = h_gtk_relation_store_finalize;
}

static void
h_gtk_relation_store_init (HGtkRelationStore *store)
{}

static void
h_gtk_relation_store_dispose (GObject *object)
{
  G_OBJECT_CLASS (h_gtk_relation_store_parent_class)->dispose (object);
}

static void
h_gtk_relation_store_finalize (GObject *object)
{
  HGtkRelationStore *self = H_GTK_RELATION_STORE (object);

  g_object_unref (self->relation);

  G_OBJECT_CLASS (h_gtk_relation_store_parent_class)->finalize (object);
}

HGtkRelationStore *
h_gtk_relation_store_new (HRelation *relation)
{
  HGtkRelationStore *store;

  g_return_val_if_fail (relation != NULL, NULL);

  store = g_object_new (H_TYPE_GTK_RELATION_STORE, NULL);

  store->relation = relation;
  g_object_ref (relation);

  return NULL;
}

