#include <gtk/gtkmain.h>
#include <glib-object.h>
#include <glib/gmacros.h>
#include <gtk/gtkmarshal.h>
#include <gtk/gtkwindow.h>

#include <libskinned/bmp_window.h>

/* Forward declarations */

static void
bmp_window_class_init (BmpWindowClass *class);
static void
bmp_window_init (GtkWidget *widget);

/* Local data */

static GtkWindowClass *parent_class = NULL;

GType
bmp_window_get_type ()
{
  static GType window_type = 0;

  if (!window_type)
    {
      static const GTypeInfo window_info =
      {
        sizeof (BmpWindowClass),
        NULL,           /* base_init */
        NULL,           /* base_finalize */
        (GClassInitFunc) bmp_window_class_init,
        NULL,           /* class_finalize */
        NULL,           /* class_data */
        sizeof (BmpWindow),
        0,              /* n_preallocs */
        (GInstanceInitFunc) bmp_window_init
      };

      window_type =
        g_type_register_static (GTK_TYPE_WINDOW, "BmpWindow",
                                &window_info, 0);
    }

  return window_type;
}

static void
bmp_window_class_init (BmpWindowClass *class)
{
  GtkObjectClass *object_class;
  GtkWidgetClass *widget_class;

  object_class = (GtkObjectClass*) class;
  widget_class = (GtkWidgetClass*) class;

  parent_class = gtk_type_class (gtk_window_get_type ());

}

void
bmp_window_hide (BmpWindow *window)
{
  g_return_if_fail (BMP_IS_WINDOW (window));

  gtk_window_get_position (GTK_WINDOW(window), &window->x, &window->y);
  gtk_widget_hide(GTK_WIDGET(window));
}

void
bmp_window_show (BmpWindow *window)
{
  g_return_if_fail (BMP_IS_WINDOW (window));
  
  gtk_window_move (GTK_WINDOW(window), window->x, window->y);
  gtk_widget_show_all(GTK_WIDGET(window));
}

static void
bmp_window_init(GtkWidget *widget)
{

	BmpWindow *window;
	window = BMP_WINDOW(widget);
}

GtkWidget*
bmp_window_new (GtkWindowType type)
{
 	GtkWidget * widget = g_object_new(bmp_window_get_type(), NULL);

	BMP_WINDOW(widget)->canvas = gtk_fixed_new();
	gtk_fixed_set_has_window (GTK_FIXED (BMP_WINDOW(widget)->canvas), TRUE);

	gtk_widget_add_events (BMP_WINDOW(widget)->canvas, GDK_ALL_EVENTS_MASK);
	gtk_container_add(GTK_CONTAINER (BMP_WINDOW(widget)), BMP_WINDOW(widget)->canvas);

	gtk_widget_realize  (GTK_WIDGET(widget));	
	gtk_widget_realize  (BMP_WINDOW(widget)->canvas);	

        gtk_window_set_decorated(GTK_WINDOW (widget), FALSE);

	return widget;
}

#if 0
static void
bmp_window_destroy (GtkObject *object)
{
}

static gboolean
bmp_window_expose (GtkWidget      *widget,
		 GdkEventExpose *event)
{

   return FALSE;
}

static gboolean
bmp_window_enter_notify(GtkWidget *widget, GdkEventCrossing *event)
{

   return FALSE;
}

static gboolean
bmp_window_leave_notify(GtkWidget *widget, GdkEventCrossing *event)
{
   return FALSE;
}

static void
bmp_window_send_configure (BmpWindow *window)
{
}

static void
bmp_window_size_allocate (GtkWidget     *widget,
				GtkAllocation *allocation)
{
}
#endif

