#ifndef MAIN_H
#define MAIN_H

#include <config.h>

#ifdef HAVE_GUI
#include "ui.h"
#endif

#include "fam_monitor.h"
#include "play.h"
#include "resource_manager.h"
#include "system_control.h"
#include "gc.h"

#include "xcs/xcs.h"
#include "bmpx/playlist.h"

#define BMP_SKIN_THUMB_DIR_BASENAME   ".thumbs"
#define BMP_SKIN_DIR_BASENAME         "skins"
#define BMP_LOG_BASENAME              "log"
#define BMP_PLAYLISTS_DIR_BASENAME    "playlists"
#define BMP_METADATA_CACHE_BASENAME   "mcache.lcm"

#define BMP_UI_BASENAME		      "ui"
#define BMP_DATA_BASENAME	      "data"
#define BMP_IMAGES_BASENAME	      "images"
#define BMP_ICONS_BASENAME	      "icons/themes"
#define BMP_HTMLHELP_BASENAME	      "htmlhelp"


#define BMP_PATH_LOG_FILE             bmp_paths[0]
#define BMP_PATH_USER_DIR             bmp_paths[1]
#define BMP_PATH_USER_PLUGIN_DIR      bmp_paths[2]
#define BMP_PATH_USER_SKIN_DIR        bmp_paths[3]
#define BMP_PATH_SKIN_THUMB_DIR       bmp_paths[4]
#define BMP_PATH_ACCEL_FILE           bmp_paths[5]
#define BMP_PATH_CONFIG_FILE          bmp_paths[6]
#define BMP_PATH_PLAYLISTS            bmp_paths[7]
#define BMP_PATH_METADATA_CACHE       bmp_paths[8]
#define BMP_N_PATHS                   9

extern gchar *bmp_paths[BMP_N_PATHS];

extern Xcs		  *xcs;

extern BmpResourceManager *bmp_rm;
extern BmpPlaylist        *bmp_playlist;
extern BmpPlay		  *bmp_play;
extern BmpSystemControl   *bmp_system_control;
extern FamMonitor	  *bmp_fam_monitor;
#ifdef HAVE_GUI
extern BmpUI              *bmp_ui;
extern gboolean		   progress_running;
#endif

extern NGC		  *ngc;

#ifndef HAVE_GUI
extern GMainLoop	  *mainloop;
#endif


#endif
