/*  BMPx - Cross-platform multimedia player
 *  Copyright (C) 2003-2004  BMPx development team.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef PREFSWIN_H
#define PREFSWIN_H

#include <glib-object.h>

#define BMP_TYPE_WINDOW_PREFERENCES		  (bmp_window_preferences_get_type ())
#define BMP_WINDOW_PREFERENCES(obj)		  (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_WINDOW_PREFERENCES, BmpWindowPreferences))
#define BMP_WINDOW_PREFERENCES_CLASS(klass)	  (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_WINDOW_PREFERENCES, BmpWindowPreferencesClass))
#define BMP_IS_WINDOW_PREFERENCES(obj)	  (GTK_CHECK_TYPE ((obj), BMP_TYPE_WINDOW_PREFERENCES))
#define BMP_IS_WINDOW_PREFERENCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_WINDOW_PREFERENCES))
#define BMP_WINDOW_PREFERENCES_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_WINDOW_PREFERENCES, BmpWindowPreferencesClass))

typedef struct _BmpWindowPreferences BmpWindowPreferences;
typedef struct _BmpWindowPreferencesClass BmpWindowPreferencesClass;
typedef struct _BmpWindowPreferencesPrivate BmpWindowPreferencesPrivate;

struct _BmpWindowPreferences {
	GObject parent;

        BmpWindowPreferencesPrivate *private;

    	GtkWidget *window;
};

struct _BmpWindowPreferencesClass {
	GObjectClass parent;
};

GType 
bmp_window_preferences_get_type (void);

BmpWindowPreferences*
bmp_window_preferences_new (void);
 
void 
bmp_preferences_window_show(BmpWindowPreferences *self);

gboolean
bmp_preferences_window_raise (BmpWindowPreferences *self);

void
bmp_window_preferences_set_font (BmpWindowPreferences *self, const gchar *font_name);
 
#endif
